#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "TimeString", Category = "String", Help = "gives a Time String based on the given Format String", Tags = "Time, Astronomy", Author = "sebl")]
	#endregion PluginInfo
	public class StringTimeStringNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("Format", DefaultString = "yyyy-MM-dd-HH-mm-ss-ff")]
		ISpread<string> FFormat;
		
		[Output("TimeString")]
		ISpread<string> FOutput;
		
//		[Output("errors")]
//		ISpread<string> FError;
		
		[Import()]
		ILogger FLogger;
		#endregion fields & pins
		
		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			FOutput.SliceCount = SpreadMax;
//			FError.SliceCount = SpreadMax;
			
			for (int i = 0; i < SpreadMax; i++)
			{
				try
				{
					FOutput[i] = DateTime.Now.ToString(FFormat[i]);
				}
				catch (FormatException e) 
				{
					FLogger.Log(LogType.Debug, "exception: " + e);
					//FError[i] = e.ToString();
				}
			}
			
			//FLogger.Log(LogType.Debug, "hi tty!");
		}
	}
}
